
	page	60,132
Code_seg	Segment
	assume	cs:code_seg,ds:code_seg,ss:code_seg
	
	org	100h
start:
	mov	ax,cs
	mov	ds,ax
	mov	ss,ax
	mov	sp,0ffffh

;	user code follows


	call	print_next
	db 	27,'[','2','J',0	; clear screen, home

program_loop:
	mov	di,0			; channel counter
	mov	si,0			; range counter
	call	print_next
	db	27,'[','H'		; home cursor
	db	'A/D test program',0
	call	print_crlf
	call	print_crlf

channel_loop:
	mov	bx,di			; get channel
	inc	di
	cmp	di,8
	ja	channel_done
	mov	ax,101h
	int	30h			; set it
	mov	si,0	

range_loop:
	mov	bx,si			; get range
	inc	si
	cmp	si,4
	ja	range_done
	mov	ax,102h
	int	30h
	
	mov	ax,103h			; get the data
	int	30h
	
	mov	ax,bx
	call	print_hex_word
	call	print_next
	db	'  ',0
	jmp	range_loop

range_done:
	call	print_crlf
	jmp	channel_loop	

			
channel_done:
	call	key_hit
	jmp	program_loop



;---------------------------------------------------------------
;
;	Prints the charactor passed in AL to the display
;
Print_char:
	mov	ah,0Eh
	int	10h
	ret				; go back

;---------------------------------------------------------------
;
;	Prints the null terminated string pointed to by SI
;
Print_string:
	push	ax			; save registers
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	
String_loop:
	mov	al,[si]			; get the char
	cmp	al,0			; end?
	jz 	string_done		; yes
	inc	si			; no, bump pointer
	push 	si			; save it
	mov 	ah,0Eh			; print char
	int	10h
	pop	si
	jmp	string_loop

String_done:
	pop	bp			; restore registers
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax

	ret				; go back

;---------------------------------------------------------------
;
;	Do a print_string and then a CRLF
;
Print_string_crlf:
	call 	print_string
	push	ax
	mov	al,0Dh
	call	print_char
	mov	al,0Ah
	call	print_char
	pop	ax
	ret

;---------------------------------------------------------------
;
;	Print a CRLF
;
Print_crlf:
	push	ax
	mov	al,0Dh
	call	print_char
	mov	al,0Ah
	call	print_char
	pop	ax
	ret

;---------------------------------------------------------------
;
; 	Print the contents of AL as a 2 char hex string
;
Print_hex_byte:
	push	cx			; save trashed registers
	push	ax			
	push	ax			; save ax locally
	
	and	al,0F0h			; zero the low nibble
	mov	cl,4			; shift over the hi nibble
	shr	al,cl
	cmp	al,0Ah			; is it A-F?
	js	its_0_9			; no
	add	al,7			; adjust it up

its_0_9:
	add	al,30h			; make everybody ascii
	call	print_char		; print it
	pop	ax			; start on the low byte
	and	al,0Fh			; zero the low nibble
	cmp	al,0Ah			; is it A-F?
	js	its_0_9_again		; no
	add	al,7			; adjust it up

its_0_9_again:
	add	al,30h			; make everybody ascii
	call	print_char		; print it
	pop	ax			; start on the low byte
	pop	cx
	
	ret

;------------------------------------------------------------------
;
;	This routine will take the value in al and print it
;	as an eight digit binary value.
;
Print_binary_byte:
	push 	ax			; save the value
	push	bx
	push	cx
	mov	bl,al
	mov	cx,8			; our loop counter, 8 bits
binary_loop:
	rcl	bl,1			; get the next bit in carry
	jc	one
	mov	al,'0'
	call 	Print_char
	jmp	around_one
one:
	mov	al,'1'
	call	Print_char
around_one:
	dec	cx
	jnz	binary_loop
	pop	cx
	pop	bx
	pop	ax
	ret

;---------------------------------------------------------------
;
; 	Print the contents of AX as a 4 char hex string		
;
Print_hex_word:
	push	ax
	mov	al,ah
	call	Print_hex_byte
	pop	ax
	call	Print_hex_byte
	ret

;---------------------------------------------------------------
;
;	Prints the ASCIIZ string that immediately follows the call
;	to this subroutine.  Continue execution after the string
;	and null terminator.  
;
;	Caution!  This routine must be invoked with a near call.
;		  To work with a far call, you must modify it to 
;		  address the string off of the pushed CS and 
;		  adjust the index into the stack to account for
;		  the additional word pushed.
;
Print_next:
	pushf				; save flags
	push	ax			; save registers
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	push	es
	push	ds
	
	mov	bp,sp
	add	bp,14h			; point to "return"
	mov	si,ss:[bp]		; get it in SI

print_loop:
	mov	al,[si]			; get the char
	cmp	al,0			; end?
	jz 	print_done		; yes
	inc	si			; no, bump pointer
	push 	si			; save it
	push	bp
	mov 	ah,0Eh			; print char
	int	10h
	pop	bp
	pop	si
	jmp	print_loop

print_done:
	inc	si			; go past null terminator
	mov	ss:[bp],si		; plug in new return

	pop	ds			; restore registers
	pop	es
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	ret				; go back

;---------------------------------------------------------------
;
;	Check for key hit, if none, return.  If hit, exit to DOS
;	
key_hit:
	push	ax
	mov	ah,1			; check for key hit
	int	16h
	pop	ax
	jz	no_hit			; no, back to caller
	mov	ah,0			; yes, swallow char so COMMAND.COM
	int	16h			; doesn't echo it
quit:
	mov	ax,4C00h		; back to dos
	int	21h
no_hit:
	ret				

;---------------------------------------------------------------
;
;	Print AL as a 2 char decimal number.  Return with no
;	action if AL > 99d.
;
print_decimal_byte:
	cmp	al,99			; is it above 99?
	ja	bad_decimal_number	; yes, leave
	push	ax			; no, save some registers
	push	si
	mov	si,offset decimal_table	; point to the translate table
	mov	ah,0
	sal	ax,1			; multiply the value by 2	
	add	si,ax			; offset into the table address
	mov	al,[si]			; get the first char
	call	print_char		; print it
	mov	al,[si+1]		; get the second char
	call	print_char		; print it
	pop	si			; restore the registers
	pop	ax
bad_decimal_number:
	ret

decimal_table:				; Ascii codes of 2 char decimal
	db	'00010203040506070809'	; numbers from 00 to 99
	db	'10111213141516171819'
	db	'20212223242526272829'
	db	'30313233343536373839'
	db	'40414243444546474849'
	db	'50515253545556575859'
	db	'60616263646566676869'
	db	'70717273747576777879'
	db	'80818283848586878889'
	db	'90919293949596979899'

code_seg 	ends

	end	start
